
class GameSettings
{
public:
	static GameSettings* mInstance;		// Singleton object
	static GameSettings* Instance();	// Singleton getter

	static const bool FULLSCREEN;
	static const bool SHOWLOG;					// das Spiel mit eingeblendetem Debug-Log starten oder nicht ?
	static const bool RENDER_BOUNDING_BOXES;
	static const bool RENDER_BACKGROUND;
	static const bool RENDER_ENEMIES;
	static const int LogFontSize;
	static const bool ASSIMP_RENDER;        // false == skip assimp render calls
	static const bool ASSIMP_IMPORT;		// use the ASSIMP importer to load the asset
	static const bool ASSIMP_SAVE;		// deserialize the imported asset (setting will automatically activate ASSIMP import)
	static const bool ASSIMP_LOAD;			// load the previously serialized assimp asset from a file
	static const bool ASSIMP_COMPARE_ASSETS;
	static const float PLAYER_ROT_SPEED_X;         // 0.3f     // die haupt-drehrichtung um die Z-Achse
	static const float PLAYER_ROT_SPEED_Y;
	static const float PLAYER_ROT_SPEED_JAW;         // wieviele grad pro ms neigt sich das plane wenn man in eine richtung steuert ?
	static const float PLAYER_ROT_MAX_JAW;        // maximale neigung des planes (in grad)
	static const float PLAYER_SPEED_MAX;         // maximale gesamtgeschwindigkeit
	static const float PLAYER_SPEED_NORMAL;        // normale gesamtgeschwindigkeit
	static const float PLAYER_SPEED_MIN;        // minimale gesamtgeschwindigkeit
	static const float PLAYER_ACCELERATION;      // nderung des gesamtgeschwindigkeit pro ms wenn accelerate gedrckt ist
	static const float PROJECTILE_SPEED_PLAYER;
	static const float CAMERA_ZOOM_SPEED;  
	static const float CAMERA_DEFAULT_POSZ;  

	static const float ENEMY_SPEED;

};